package no.uia.dat101.sett10.grafikk;

import java.awt.Color;
import java.awt.Graphics;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;

import no.uia.dat101.oppg10.interfaces.TegneFigur;

/**
 * Model klassen kontrollerer all tegningsdata; arraylist, jlist, x, y, dx, dy, fasong, tegnemate, mus bruk, og sletting av tegninger.
 * @author Administrator
 *
 */
public class Model {

	public enum Fasong {LINJE,OVAL,REKTANGEL};
	private int dx; private int finaldx;
	private int dy; private int finaldy;
	private int x; private int y;
	private Fasong fasong;
	private Color farge;
	private boolean tegnemate;
	private boolean directinput;
	ArrayList<TegneFigur> al=new ArrayList<TegneFigur>();	
	private DefaultListModel listeModel =new DefaultListModel();
	private Color selected_color = new Color(200,200,255);
	
	public void tegn (Graphics g) {
		/*
		if (fasong == "linje") {
			Linje t = new Linje();
			t.tegn(g);
			this.add(t);
		} else if (fasong == "oval") {
			Oval  t = new Oval();			
			t.tegn(g);
			this.add(t);
		} else if (fasong == "rektangel"){
			Rektangel t = new Rektangel();
			t.tegn(g);
			this.add(t);
		}*/

		int alsize = al.size();		
		for (int i = 0; i < alsize; ++i) {
			al.get(i).tegn(g);
		}
	}

	public void add(TegneFigur tf,boolean dragging) {
		al.add(tf);
		if (!dragging) listeModel.add(0,tf);	

	}
	public ArrayList<TegneFigur> getTegninger() {
		return al;
	}

	public void setTegninger(ArrayList<TegneFigur> ny) {
		this.al = ny;
	}
	public int getDx() {
		return dx;
	}

	public void setDx(int dx) {
		this.dx = dx;
	}

	public int getDy() {
		return dy;
	}

	public void setDy(int dy) {
		this.dy = dy;
	}

	public Fasong getFasong() {
		return fasong;
	}

	public void setFasong(Fasong fasong) {
		this.fasong = fasong;
	}

	public Color getFarge() {
		return farge;
	}

	public void setFarge(Color farge) {
		this.farge = farge;
	}

	public boolean isTegnemate() {
		return tegnemate;
	}

	public void setTegnemate(boolean tegnemate) {
		this.tegnemate = tegnemate;
	}

	public ArrayList<TegneFigur> getAl() {
		return al;
	}

	public void setAl(ArrayList<TegneFigur> al) {
		this.al = al;
	}
	
	// for dragging og finne strrelse p figur
	public int getX() {
		return x;
	}

	public void setX(int x) {
		this.x = x;
	}

	public int getY() {
		return y;
	}

	public void setY(int y) {
		this.y = y;
	}
	
	// velge mus strrelse eller manuelt
	public boolean isDirectinput() {
		return directinput;
	}

	public void setDirectinput(boolean directinput) {
		this.directinput = directinput;
	}

	// slet alle
	public void slettAlle() {
		al.removeAll(al);
	}

	public void slettIndexNr(int siste) {
		int size = al.size();
		al.remove(size-siste);
	}
	
	// listeModel metoder
	public DefaultListModel getListeModel() {
		return listeModel;
	}
	
	// slett tegning fra liste
	public void slettTegning(TegneFigur tf) {
		al.remove(tf);
		listeModel.removeElement(tf);
	}
	
	// farge for meny p venstre side
	public Color getSelectedColor() {
		return selected_color;
	}

	public void setSelectedColor(Color selected_color) {
		this.selected_color = selected_color;
	}

	// verdier for definer strrelse tekst felter
	public int getFinalDx() {
		return finaldx;
	}

	public void setFinalDx(int finaldx) {
		this.finaldx = finaldx;
	}

	public int getFinalDy() {
		return finaldy;
	}

	public void setFinalDy(int finaldy) {
		this.finaldy = finaldy;
	}

}
